#
# mkreadme,  1 Jun 17

# Turn <book blah_99> into \cite{blah_99}
# and merge adjacent \cite{...}\cite{...}
# plus
# Convert dblatex generated latex so Margin figures are treated as such
function tex_post_pro()
{
# Special case needed to support equations in footnotes
# Convert to latex cross reference referencing
sed -e "1,/^\\\\mainmatter/d" \
    -e "s/S\\\\_\\\\\\$/\\\\$/g"  \
    -e "s/S\\\\_/\\\\/g"  \
    -e "s/\\\\lt/</g" \
    -e "s/\\\\gt/>/g" \
    -e "s/FooTNotE/\\\\footnote{/g" \
    -e "s/EtoNTooF/}/g" \
    -e "s/ \\\\footnote/\\\\footnote/g" \
    -e "s/CoLoR\\\\_\([a-zA-Z]\+\)\\\\_(\([^)]\+\))/\\\\textcolor{\1}{\2}/g" \
    -e "s/LletBlet\([a-zA-Z]\)\([a-zA-Z]\)/\\\\\1{\2}/g" \
    -e "s/Lletlet\([a-zA-Z][a-zA-Z]\)/{\\\\\1}/g" \
    -e "s/Laccup\([a-zA-Z]\)/{\\\\'\1}/g" \
    -e "s/Ldotdot\([a-zA-Z]\)/{\\\\\"\1}/g" \
    -e "s/Loslash/{\\\o}/g" \
    -e "s/LOslash/{\\\O}/g" \
    -e "s/\\\\href{\\\\#\([a-zA-Z0-9_\-]\+\)}{Figure}/Figure~\\\\ref{\1}/g" \
    -e "s/\\\\href{\\\\#\([a-zA-Z0-9_\-]\+\)}{Fig}/Fig~\\\\ref{\1}/g" \
    -e "s/\\\\href{\\\\#\([a-zA-Z0-9_\-]\+\)}{Table}/Table~\\\\ref{\1}/g" \
    -e "s/\\\\hyperlink{\([^}]\+\)}{Table}/Table~\\\\ref{\1}/g" \
    -e "s/\\\\begin{table}\[htbp]/\\\\begin{table*}/" \
    -e "s/\\\\end{table}/\\\\end{table*}/" \
    -e "s/\\\\chapter{Statistics for software engineering}/\\\\begin{adjustwidth*}{0.0cm}{-2.7cm}\\\\chapter{Statistics for software engineering}\\\\end{adjustwidth*}/" \
    -e "/^\\\\end.document.$/d"  | \
awk -e '{ if (index($0, "<{}book") == 0) \
	     { print $0; next }  \
	  buffer=$0;  \
	  if (index($NF, "<{}book") != 0)  \
	     { getline ; buffer=buffer " " $0 }  \
	  gsub("<\\{}book ", "\\cite{", buffer)  \
	  gsub("-\\{}", "-", buffer)  \
	  gsub("\\\\_", "_", buffer)  \
	  gsub("penalty5000 _", "_", buffer) \
	  gsub("penalty0 art_", "penalty0 art\\_", buffer) \
	  gsub(">{", "", buffer);  \
	  print buffer  \
         }'   | \
# awk -e '{ if (index($1, "\\begin{lstlisting}") != 0) \
# 	      { printf("\\begin{table*}\n%s\n", $0); next} \
# 	  if (index($1, "\\end{lstlisting}") != 0) \
# 	      { printf("%s\n\\end{table*}\n", $0); next} \
# 	  print $0; next; \
#          }'   | \
awk -e '{ if ($1 != "mp.\\footnote{") \
	      { print $0; next} \
	  getline; \
	  print "\\marginpar{"; \
	  while ($1 != "}") { \
	     gsub(" NeWlInE", "\\\\", $0); print $0;\
	     getline; }; \
	  print $0; \
         }'   | \
# Potentially put Figures in the margin \
# Add in latex label for cross referencing \
awk -e '{ if ($1 != "\\begin{figure}[H]") \
	      { print $0; next} \
	  getline; getline; getline; \
	  split($0, curl_str, "{"); \
	  gsub("not_R/", "", curl_str[2]); \
	  lab_str="\\label{" substr(curl_str[2], 1, length(curl_str[2])-5) "}"; \
	  if (index($0, "caption=\"Margin ") == 0) \
	     { \
	     printf("\\begin{figure*}[H]\n\\begin{center}\n%s\n", $0); \
	     getline; getline; \
	     gsub("caption{", "sidecaption{", $0); \
	     gsub("caption\\[", "sidecaption[", $0); \
	     gsub("}$", "", $0); \
	     printf("%s%s}\n\\end{center}\n\\end{figure*}\n", $0, lab_str); \
	     getline; next} \
	  gsub("\"Margin ", "\"Figure ", $0); \
	  printf("\\begin{marginfigure}\n%s\n", $0); \
	  getline; getline; \
#	  gsub("caption{", "caption{" lab_str, $0); \
#	  cap_str=gensub("caption(\\[\\{)", "caption\\1" lab_str, "g", $0); \
	  printf("%s%s\n\\end{marginfigure}\n", $0, lab_str); \
	  getline; if ($1 != "\\end{figure}") print ">> NOT END <<" \
         }'   | \
sed -e "s/\(_[0-9][0-9]\)}\\\cite{/\1,/g"
}


base_file="readme1st"

sed -e "s/<equ>/latexmath:[$/g" \
    -e "s/<\/equ>/$]/g" \
    -e "s/<EQU>/latexmath:[$\\\\begin{aligned}/g" \
    -e "s/<\/EQU>/\\\\end{aligned}$]/g" \
    -e "s/<footnote>/FooTNotE/g" \
    -e "s/<\/footnote>/EtoNTooF/g" \
    -e "s/<B>/*/g" \
    -e "s/<\/B>/*/g" \
    -e "s/<keyword>/*/g" \
    -e "s/<\/keyword>/*/g" \
    -e "s/<code>/++pass:[/g" \
    -e "s/<\/code>/]++/g" \
    -e "s/<Rcode>/++/g" \
    -e "s/<\/Rcode>/++/g" \
    -e "s/<rcode>/++pass:[/g" \
    -e "s/<\/rcode>/]++/g" \
    -e "s/<Roption>/++/g" \
    -e "s/<\/Roption>/++/g" \
    -e "s/<roption>/++pass:[/g" \
    -e "s/<\/roption>/]++/g" \
    -e "s/<routput>/++pass:[/g" \
    -e "s/<\/routput>/]++/g" \
    -e "s/<file>/++pass:[/g" \
    -e "s/<\/file>/]++/g" \
    -e "s/<command>/++pass:[/g" \
    -e "s/<\/command>/]++/g" \
    -e "s/<phrase>/_/g" \
    -e "s/<\/phrase>/_/g" \
    -e "s/<quote>/\`/g" \
    -e "s/<\/quote>/\'/g" \
    -e "s/javaident\[\([^]]\+\)\]/++\1++/g" \
    -e "s/program\[\([^]]\+\)\]/++\1++/g" \
    -e "s/squote\[\([^]]\+\)\]/pass:[\'\1\']/g" \
    -e "s/C++/\&CCPP;/g" \
    -e "s/\\\\\([a-zA-Z]\){\([a-zA-Z]\)}/LletBlet\1\2/g" \
    -e "s/{\\\\\([a-zA-Z][a-zA-Z]\)}/Lletlet\1/g" \
    -e "s/{\\\\'\([a-zA-Z]\)}/Laccup\1/g" \
    -e "s/{\\\\\"\([a-zA-Z]\)}/Ldotdot\1/g" \
    -e "s/{\\\\o}/\&Loslash;/g" \
    -e "s/{\\\\O}/\&LOslash;/g" \
 readme1st.txt | asciidoc -a latexmath -b docbook45 -d book $2 $3 $4 $5 $6 $7 $8 $9 -o "$base_file".xml  -

echo '<?xml version="1.0" encoding="UTF-8"?>
      <!DOCTYPE book [
      <!ENTITY % myent SYSTEM "/home/derek/.dblatex/Sentities.ent">
      %myent;
      ]>' > t.t

sed -s "1,2d" "$base_file".xml >> t.t

mv t.t "$base_file".xml

dblatex "$base_file".xml -t tex

tex_post_pro  < "$base_file".tex  > ../tex/readme1st.tex

# lualatex -interaction=batchmode tex/"$base_file".tex

